export default function runPreParseHook({ args, preParseHook, fail }: {
  args: string[],
  preParseHook?: (args: string[], fail: (message: string) => void) => (string[] | undefined),
  fail: (errorMessage: string) => void,
}): string[] {
  if (preParseHook === undefined) {
    return args;
  }

  try {
    const modifiedArgs = preParseHook(args, fail);
    return modifiedArgs !== undefined ? modifiedArgs : args;
  } catch (error) {
    fail(`Could not run pre-parse hook, encountered error: ${String(error)}.`);
    return [];
  }
}
